$source_location = File.dirname(__FILE__)

module LoremKnight
  class Panther
    attr_accessor :paragraph_size
    attr_accessor :sentence_size
    attr_accessor :list_size
    attr_accessor :word_length
    attr_accessor :has_pre_sentence

    def initialize
      #
      source = File.open("#{$source_location}/raw/words.txt", "r+")
      @content = source.sysread(source.size).split(" ")
      
      # initialize default lorem config vars
      @paragraph_size = 70
      @sentence_size = 7
      @list_size = 5
      @word_length = 20
      @list_standart_size = 10
  
      @content_type = "RAW"
      @has_pre_sentence = false
    end

    def get_sentence(quantity)
      generate_lorem(quantity, @sentence_size)
    end

    def get_paragraph(quantity)
      generate_lorem(quantity, @paragraph_size)
    end

    def get_list(quantity)
      lists = ""
      quantity.to_i.times { lists += generate_list }
      return lists
    end

    def get_words(quantity)
      words = ""
      word_array = words.split(" ")

      while word_array.length < quantity.to_i do
        pending_word = @content[rand(@content.size)]
        words += pending_word.length <= @word_length ? pending_word + " " : ""
        word_array = words.split(" ")
      end
      return words.force_encoding('UTF-8')
    end

    def set_content_type(type)
      case(type.to_s)
      when "html"
        @content_type = "text/html"
      when "raw"
        @content_type = "RAW"
      else
        @content_type = "RAW"
      end
    end

    def generate_lorem(quantity, length, prefix = '')
      pre_sentence = @has_pre_sentence == true ? "რომელმან შექმნა სამყარო" : ""
      lorem = @content_type == 'text/html' ? "<p> #{pre_sentence} " : "#{pre_sentence} "

      quantity.times do |i|
        length.times do
          lorem += (@content[rand(@content.size)] + " ").force_encoding('UTF-8')
        end
          case(@content_type)
          when "text/html"
            lorem += i != quantity - 1 ? " </p>  <p> #{pre_sentence} " : " </p>"
          when "RAW"
            lorem += i != quantity - 1 ? "\n #{pre_sentence} " : ""
          end
      end
      return lorem.force_encoding('UTF-8')
    end

    def generate_list
      pre_sentence = @has_pre_sentence == true ? "რომელმან შექმნა სამყარო" : ""
    	list = "<ul><li>"
    	randomSize = rand(20) 

    	@list_standart_size.times do |x|
    		list += " #{pre_sentence}"
    		randomSize.times do |y|
    			list += y != randomSize-1 ? " #{@content[rand(@content.size-1)]}" : " #{@content[rand(@content.size-1)]}</li>"
    		end
    		list += x != @list_standart_size-1 ? "<li>" : "</ul>"
    	 end
    	return list.force_encoding('UTF-8')
    end
  end
end
